<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Save ServiceType
 * @subpackage Services
 */
class Save extends AbstractSoapClientBase
{
    /**
     * Method to call the operation originally named SaveAbandonementCart
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\SaveAbandonementCart $parameters
     * @return \StructType\SaveAbandonementCartResponse|bool
     */
    public function SaveAbandonementCart(\StructType\SaveAbandonementCart $parameters)
    {
        try {
            $this->setResult($this->getSoapClient()->SaveAbandonementCart($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\SaveAbandonementCartResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
}
